> For the complete documentation index, see [llms.txt](https://docs.atfinity.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.atfinity.io/document-xml-adx/adx-elements/template.md).

# Template

The `<template>` tag needs to be added within `<pageTemplates>` directly below the root tag. Each template needs to have an id to refer to it later. Content within a template is rendered with exact positioning (HTML speak: absolute position).

## Example

```markup
<adx>
  <pageTemplates>
    <template
      id="simple_header"
      pageSize="A4"
      pageMargins="10cm 2cm 5cm 2cm"
    >
        <text
          bottom="287mm"
          left="20mm"
          width="190mm"
          height="10mm"
          color="white"
          fontSize="80"
        >
            Header
        </text>
    </template>
  </pageTemplates>
  <body template="simple_header">
  ...
  </body>
</adx>
```

## Attributes

#### `id`

The unique identifier of the template. Referenced via the `template` or `firstPageTemplate` attribute on `<body>`.

#### `pageSize` (optional)

The page size as two lengths separated by a space (width height), e.g. `"210mm 297mm"`. The shorthand `"A4"` is equivalent to `"210mm 297mm"`. Defaults to `"210mm 297mm"` (A4).

#### `pageMargins` (optional)

Four lengths separated by spaces, in TRouBLe order (Top Right Bottom Left), e.g. `"10cm 2cm 5cm 2cm"`. Defaults to `"2cm 2cm 2cm 2cm"`.

## Allowed Children

A `<template>` can contain the following elements (rendered with absolute positioning):

* `<rect>`
* `<line>`
* `<text>`
* `<h1>`, `<h2>`
* `<image>`
* `<pageNumber>`
* `<qrCode>`
* `<hrCode>`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.atfinity.io/document-xml-adx/adx-elements/template.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
